#!/usr/bin/perl

require "config.pl";

use CGI;
use MP3::Info qw(:all);
$|=1;

$query = new CGI();

print $query->header();
&startHTML();


$path = $query->param('path');

$find = $query->param('find');
$list = $query->param('list');
$edit = $query->param('edit');
$save = $query->param('ed_save');

if (defined($find)){
  print '<IMG SRC="search.gif" HEIGHT="16" WIDTH="16"
          TITLE="Search Results" ALIGN="absmiddle" BORDER="0"> ';
  print '<A HREF="browse.cgi?list='.&ue($list);
  print '" TITLE="click here to browse again">';
  print '<B>Search Results</B></A><BR><BR>';
  print '<TABLE><TR><TD NOWRAP>';
  &search($path,$find,$list);
  print '</TD></TR></TABLE>';
}elsif(defined($edit)){
  &id3edit($list,$edit);
}else{
  if ($save){
    &id3save();
  }
  print '<TABLE><TR><TD NOWRAP>';
  &readFiles($path,$list);
  print '</TD></TR></TABLE>';
}

&endHTML();


#########################################################
sub readFiles($$) {
  my $path=$_[0];
  my $list=$_[1];
  my ($file,@files,$fullFilename,$display);

  opendir(ROOT, $REALDIR.$path);
  @files = sort(readdir(ROOT));
  closedir(ROOT);
  $display = $path;
  $display = "Filebrowser" if ($display eq '');

  print '<IMG SRC="folder.gif" HEIGHT="16" WIDTH="16" TITLE="Folder" ALIGN="absmiddle"> ';
  print "<B>$display</B><BR><BR>";

  foreach $file (@files) {
    next if ( ($file =~ m/^\./) and ($file !~ m/^\.\.$/) );
    next if (($path eq '') and ($file =~ m/^\.\.$/));
    &printFile($file,"$path/$file",$list);
  }
  
}

sub search($$$){
  my $path=$_[0];
  my @find=split(" ",$_[1]);
  my $list=$_[2];
  my ($file,@files,$fullFilename,$found,$srch);

  opendir(ROOT,$REALDIR.$path);
  @files = sort(readdir(ROOT));
  closedir(ROOT);

  foreach $file (@files) {
    next if ($file =~ m/^\./);
    $fullFilename    = "$path/$file";
    foreach $srch (@find){
      if ($file =~ m/$srch/i){
        $found = 1;
      }else{
        $found = 0;
        last;
      }
    }
    &printFile($file,$fullFilename,$list) if $found;

    if (-d $REALDIR.$fullFilename){
      &search($fullFilename,$find,$list);
    }
  }
}

sub printFile($$$){
  my $file         = $_[0];
  my $fullFilename = $_[1];
  my $list         = $_[2];
     $list         = &ue($list);
  my ($ext,$name,$info);

  if ($file =~ m/^\.\.$/){  #updir
    $fullFilename = substr($fullFilename, 0, rindex($fullFilename,'/'));
    $name         = $fullFilename;
    $name         =~ s/[^A-Za-z0-9]//g;
    $fullFilename = substr($fullFilename, 0, rindex($fullFilename,'/'));
    $fullFilename = &ue($fullFilename);
    print "<A HREF=\"browse.cgi?path=$fullFilename&list=$list#$name\">";
    print '<IMG SRC="up.gif" HEIGHT="16" WIDTH="16" TITLE="up" ALIGN="absmiddle" BORDER="0"> ';
    print "..</A>";

  }elsif (-d $REALDIR.$fullFilename) { #directories
    $name         = $fullFilename;
    $name         =~ s/[^A-Za-z0-9]//g;
    $fullFilename = &ue($fullFilename);
    print "<A HREF=\"browse.cgi?path=$fullFilename&list=$list\" NAME=\"$name\">";
    print '<IMG SRC="folder.gif" HEIGHT="16" WIDTH="16" TITLE="Folder" ALIGN="absmiddle" BORDER="0"> ';
    print "$file</A>";

    if ($list ne ''){
      print "<A HREF=\"edit.cgi?dir=$fullFilename&list=$list#bottom\" TARGET=\"right\">";
      print '<IMG SRC="add.gif" HEIGHT="16" WIDTH="16" TITLE="Add recursively to playlist" ALIGN="absmiddle" BORDER="0">';
      print "</A>";
    }

  }elsif ($fullFilename =~ /^.*\.(mp3)$/i) { #mp3s
    $info = &mp3info($fullFilename);
    $fullFilename = &ue($fullFilename);
    
    print "<A HREF=\"browse.cgi?list=$list&edit=".$fullFilename.'">';
    print '<IMG SRC="mp3.gif" HEIGHT="16" WIDTH="16" ALIGN="absmiddle" BORDER="0" '.$info.'>';
    print '</A> ';

    print "<A HREF=\"play.cgi?music=$fullFilename\" TITLE=\"play\">";
    print "$file</A> ";
    if ($list ne ''){
      print "<A HREF=\"edit.cgi?new=$fullFilename&list=$list#bottom\" TARGET=\"right\">";
      print '<IMG SRC="add.gif" HEIGHT="16" WIDTH="16" TITLE="Add to playlist" ALIGN="absmiddle" BORDER="0">';
      print "</A>";
    }

  }elsif ($fullFilename =~ /^.*\.(wma|wav|ogg)$/i) { #other audiofiles
    $ext = $1;
    $fullFilename = &ue($fullFilename);
    print '<IMG SRC="'.lc($ext).'.gif" HEIGHT="16" WIDTH="16" TITLE="'.uc($ext).'" ALIGN="absmiddle" BORDER="0"> ';
    print "<A HREF=\"play.cgi?music=$fullFilename\" TITLE=\"play\">";
    print "$file</A> ";
    if ($list ne ''){
      print "<A HREF=\"edit.cgi?new=$fullFilename&list=$list#bottom\" TARGET=\"right\">";
      print '<IMG SRC="add.gif" HEIGHT="16" WIDTH="16" TITLE="Add to playlist" ALIGN="absmiddle" BORDER="0">';
      print "</A>";
    }
  }else{
    next;
  }

  print "<BR>\n";
}

sub mp3info($){
  my $fullFilename = $_[0];
  my $info = get_mp3info($REALDIR.$fullFilename);

  my $ret = '';

  if ($info->{BITRATE} < 96){
    $ret .= 'CLASS="lowbr"';
  }elsif ($info->{BITRATE} < 128){
    $ret .= 'CLASS="medbr"';
  }else{
    $ret .= 'CLASS="hibr"';
  }

  $ret .= '" TITLE="MP3 ('.$info->{TIME}.'@'.$info->{BITRATE}.' kbps';
  $ret .= ' VBR' if ($info->{VBR});
  $ret .= ') &raquo;click to edit id3 tag&laquo;"';

  return $ret;
}

sub id3edit($$){
  my $list = $_[0];
  my $file = $_[1];
  my $check = 'checked' if $RENAMEONTAG;

  my $tag = get_mp3tag($REALDIR.$file,1);
  my $info = get_mp3info($REALDIR.$file);

  my ($path,$name,$back,$head,$fullFilename);
  $path = $file;
  $path = substr($path, 0, rindex($path,'/'));
  $name = $path;
  $name =~ s/[^A-Za-z0-9]//g;
  $back = "<A HREF=\"browse.cgi?path=".&ue($path)."&list=$list#$name\">".
          '<IMG SRC="back.gif" HEIGHT="16" WIDTH="16" TITLE="back"
           ALIGN="absmiddle" BORDER="0"></A>';
  $head = $file;
  $fullFilename = &ue($head);

  my $genre = &genreSel($tag->{GENRE});
  my %mode =(0 => 'stereo',
             1 => 'joint stereo',
             2 => 'dual channel',
             3 => 'single channel');

  print <<endHTML;

  <IMG SRC="mp3.gif" HEIGHT="16" WIDTH="16" TITLE="MP3" ALIGN="absmiddle" BORDER="0">
  <A HREF="play.cgi?music=$fullFilename" TITLE="play">
  <B>$head</B></A>
  <BR><BR>

  $info->{BITRATE} kbps $info->{FREQUENCY} kHz $mode{$info->{MODE}}
  <BR>
  $info->{MM} Minutes $info->{SS} Seconds
  

  <FORM ACTION="browse.cgi" METHOD="post">
  <INPUT TYPE="hidden" NAME="list" VALUE="$list">
  <INPUT TYPE="hidden" NAME="path" VALUE="$path">
  <INPUT TYPE="hidden" NAME="ed_save" VALUE="1">
  <INPUT TYPE="hidden" NAME="ed_file" VALUE="$file">
  <TABLE>
  <TR>
    <TD>Artist</TD>
    <TD>
        <INPUT TYPE="text" CLASS="input" NAME="ed_artist" VALUE="$tag->{ARTIST}"
         SIZE="34" MAXLENGTH="30">
    </TD>
  </TR>
  <TR>
    <TD>Title</TD>
    <TD>
        <INPUT TYPE="text" CLASS="input" NAME="ed_title" VALUE="$tag->{TITLE}"
         SIZE="34" MAXLENGTH="30">
    </TD>
  </TR>
  <TR>
    <TD>Album</TD>
    <TD>
        <INPUT TYPE="text" CLASS="input" NAME="ed_album" VALUE="$tag->{ALBUM}"
         SIZE="34" MAXLENGTH="30">
    </TD>
  </TR>
  <TR>
    <TD>Year</TD>
    <TD>
        <INPUT TYPE="text" CLASS="input" NAME="ed_year" VALUE="$tag->{YEAR}"
         SIZE="4" MAXLENGTH="4">&nbsp;&nbsp;
        Genre
        $genre
    </TD>
  </TR>
  <TR>
    <TD>Comment</TD>
    <TD>
        <INPUT TYPE="text" CLASS="input" NAME="ed_comment" VALUE="$tag->{COMMENT}"
         SIZE="34" MAXLENGTH="30">
    </TD>
  </TR>
  <TR>
    <TD>Track#</TD>
    <TD>
        <INPUT TYPE="text" CLASS="input" NAME="ed_track" VALUE="$tag->{TRACKNUM}"
         SIZE="2" MAXLENGTH="2">&nbsp;&nbsp;
        <INPUT TYPE="checkbox" NAME="ed_rename" VALUE="1" $check>rename file
    </TD>
  </TR>
   <TR>
    <TD>
        $back
    </TD>
    <TD ALIGN="right">
        <INPUT TYPE="image" SRC="save.gif" TITLE="save">
    </TD>
  </TR>
  </TABLE>
  </FORM>
endHTML

}

sub id3save(){
  my $ed_file    = $query->param('ed_file');
     $ed_file    = $REALDIR.$ed_file;
  my $ed_title   = $query->param('ed_title');
  my $ed_artist  = $query->param('ed_artist');
  my $ed_album   = $query->param('ed_album');
  my $ed_year    = $query->param('ed_year');
  my $ed_genre   = $query->param('ed_genre');
  my $ed_comment = $query->param('ed_comment');
  my $ed_track   = $query->param('ed_track');
  my $ed_rename   = $query->param('ed_rename');

  set_mp3tag ($ed_file,$ed_title,$ed_artist,$ed_album,$ed_year,
              $ed_comment,$ed_genre,$ed_track);

  if ($ed_rename){
    my $path = substr($ed_file, 0, rindex($ed_file,'/'));
    my $newname = $MP3SYNTAX;
    $newname =~ s/\%a/$ed_artist/g;
    $newname =~ s/\%t/$ed_title/g;
    $newname =~ s/\%d/$ed_album/g;
    $newname =~ s/\%c/$ed_comment/g;
    $newname =~ s/\%y/$ed_year/g;
    $newname =~ s/\%n/$ed_track/g;
    $newname =~ s/\%g/$ed_genre/g;
    $newname =  $path.'/'.$newname.'.mp3';

    $newname =~ s/ /_/g;    #Spaces
    $newname =~ s/%20/_/g;
    $newname =~ s/--/-/g;   #Reduce multiple dashes to one
    $newname =~ s/_-_/-/g;  #Dashes should not be surounded by underscores
    $newname =~ s/;/_/g;    #remove semicolons
    $newname =~ s/\\//g;    #remove backslashes
    $newname =~ s/_-/-/g;
    $newname =~ s/-_/-/g;
    $newname =~ s/__/_/g;   #Reduce multiple spaces to one
    
    rename ($ed_file,$newname);
  }
}

sub genreSel($){
  my $sel =$_[0];
  my $ret ='';

  push (@mp3_genres,''); 
  @mp3_genres = sort(@mp3_genres); 
  my ($check,$genre);
  $ret .= '<SELECT NAME="ed_genre" CLASS="input">';
  foreach $genre (@mp3_genres){
    if ($sel =~ m/^$genre$/i){
      $check='SELECTED';
    }else{
      $check='';
    }
    $ret .= '<OPTION VALUE="'.$genre."\" $check>".$genre.'</OPTION>';
  }
  $ret .= '</SELECT>';
  return $ret;
} 
