#!/usr/bin/perl

require "config.pl";

use CGI;

$query = new CGI();

print $query->header();
&startHTML();

$list = $query->param('list');
$name = $query->param('name');

if (defined($name)){
  rename ("$SAVEDIR/$name.m3u","$SAVEDIR/$list.m3u");
}

if ($list ne ''){
  &printHeader($list);

  $new  = $query->param('new');
  &add($list,$new) if (defined($new));

  $dir  = $query->param('dir');
  &adddir($list,$dir) if (defined($dir));

  $up   = $query->param('up');
  $down = $query->param('down');
  $del  = $query->param('del');
  $sort = $query->param('sort');

  &sort($list) if ($sort eq 'sort');
  &shuffle($list) if ($sort eq 'shuffle');

  print '<TABLE><TR><TD NOWRAP>';
  &read($list,$up,$down,$del);
  print '</TD></TR></TABLE>';
}else{
  print '<H4>No playlist loaded</H4>';
  print '<A HREF="menu.cgi">Go back</A> and select one.';
}

&endHTML();



###############################################################################

sub printHeader($){
  my $list = $_[0];
  print '<TABLE WIDTH="100%"><TR><TD>';
  print '<FORM ACTION="browse.cgi" TARGET="left">';
  print '<B>Search:</B><BR>';
  print "<INPUT TYPE=\"hidden\" NAME=\"list\" VALUE=\"$list\">";
  print '<INPUT TYPE="text" NAME="find" CLASS="input">';
  print ' <INPUT TYPE="image" SRC="search.gif" TITLE="search song">';
  print '</FORM>';
  print '</TD><TD>';
  print '<FORM ACTION="frame.cgi" METHOD="post" TARGET="main">';
  print '<B>Playlist:</B><BR>';
  print '<INPUT TYPE="hidden" NAME="left" VALUE="browse.cgi">';
  print '<INPUT TYPE="hidden" NAME="right" VALUE="edit.cgi">';
  print "<INPUT TYPE=\"hidden\" NAME=\"name\" VALUE=\"$list\">";
  $list =~ s/.m3u$//;
  print "<INPUT TYPE=\"text\" VALUE=\"$list\" NAME=\"list\" CLASS=\"input\">";
  print ' <INPUT TYPE="image" SRC="save.gif" TITLE="rename list">';

  print ' <A HREF="menu.cgi" TARGET="main">';
  print '<IMG SRC="close.gif" BORDER="0" WIDTH="16" HEIGHT="16" TITLE="close list"></A>';
  $list = &ue($list);
  print " <A HREF=\"play.cgi?list=$list\">";
  print '<IMG SRC="play.gif" BORDER="0" WIDTH="16" HEIGHT="16" TITLE="play list"></A>';

  print " <A HREF=\"edit.cgi?list=$list&sort=sort\">";
  print '<IMG SRC="sort.gif" BORDER="0" WIDTH="16" HEIGHT="16" TITLE="sort list"></A>';
  print " <A HREF=\"edit.cgi?list=$list&sort=shuffle\">";
  print '<IMG SRC="shuffle.gif" BORDER="0" WIDTH="16" HEIGHT="16" TITLE="shuffle list"></A>';

  print '&nbsp;&nbsp;&nbsp;&nbsp;';
  print " <A HREF=\"menu.cgi?dellist=$list\"
           TARGET=\"main\" onClick=\"return confirm('Really delete the whole playlist?')\">";
  print '<IMG SRC="del.gif" BORDER="0" WIDTH="16" HEIGHT="16"
          TITLE="delete list"></A>';
  print '</FORM>';
  print '</TD></TR></TABLE>';
}

sub sort($){
  my $list = $_[0];

  open (LIST, "$SAVEDIR/$list.m3u") || die("could not open $SAVEDIR/$list");
  my @m3u = <LIST>;
  close (LIST);
  @m3u = sort (@m3u);
  open (LIST, ">$SAVEDIR/$list.m3u") || die("could not open $SAVEDIR/$list");
  print LIST @m3u;
  close (LIST);
}

sub shuffle($){
  my $list = $_[0];

  open (LIST, "$SAVEDIR/$list.m3u") || die("could not open $SAVEDIR/$list");
  my @m3u = <LIST>;
  close (LIST);
  my @new;
  while (scalar(@m3u)){
    $pos = int(rand (scalar(@m3u)));
    push (@new, splice(@m3u,$pos,1));
  }
  open (LIST, ">$SAVEDIR/$list.m3u") || die("could not open $SAVEDIR/$list");
  print LIST @new;
  close (LIST);
}

sub add($$){
  my $list = $_[0];
  my $new  = $_[1];
  $new = $RELDIR.$new;

  open (LIST, ">>$SAVEDIR/$list.m3u") || die("could not open $SAVEDIR/$list");
  print LIST "$new\n"; 
  close (LIST);
}

sub adddir($$){
  my $list  = $_[0];
  my $path  = $_[1];

  opendir(DIR,$REALDIR.$path);
  my @files = sort(readdir(DIR));
  closedir(DIR);

  foreach my $file (@files){
    next if ($file =~ m/^\./);
    if (-d $REALDIR.$path.'/'.$file){
      &adddir($list,$path.'/'.$file);
      next;
    }
    if ($file =~ m/\.(mp3|wma|wav|ogg)$/i){
      &add($list,$path.'/'.$file);
    }
  }
}

sub read($$$){
  my $list = $_[0];
  my $up   = $_[1];
  my $down = $_[2];
  my $del  = $_[3];

  open (LIST, "$SAVEDIR/$list.m3u") || die("could not open $SAVEDIR/$list");
  my @m3u = <LIST>;
  close (LIST);

  my ($temp); 
  if (defined($up)){
    $temp       = $m3u[$up];
    $m3u[$up]   = $m3u[$up-1];
    $m3u[$up-1] = $temp;
    open (LIST, ">$SAVEDIR/$list.m3u") || die("could not open $SAVEDIR/$list");
    print LIST @m3u;
    close (LIST);
  }
  if (defined($down)){
    $temp       = $m3u[$down];
    $m3u[$down]   = $m3u[$down+1];
    $m3u[$down+1] = $temp;
    open (LIST, ">$SAVEDIR/$list.m3u") || die("could not open $SAVEDIR/$list");
    print LIST @m3u;
    close (LIST);
  }
  if (defined($del)){
    splice (@m3u,$del,1); 
    open (LIST, ">$SAVEDIR/$list.m3u") || die("could not open $SAVEDIR/$list");
    print LIST @m3u;
    close (LIST);
  }


  my $row=0;
  foreach $line (@m3u){
    $line =~ s/^$RELDIR//;
    $line =~ s/\s+$//;

    print "<A HREF=\"edit.cgi?del=$row&list=$list\">";
    print '<IMG SRC="del.gif" HEIGHT="16" WIDTH="16" TITLE="Remove from list" ALIGN="absmiddle" BORDER="0">';
    print "</A>";

    if ($row != 0){
      print "<A HREF=\"edit.cgi?up=$row&list=$list\">";
      print '<IMG SRC="moveup.gif" HEIGHT="16" WIDTH="16" TITLE="Move up" ALIGN="absmiddle" BORDER="0">';
      print "</A>";
    }else{
      print '<IMG SRC="blank.gif" HEIGHT="16" WIDTH="16" TITLE="" ALIGN="absmiddle" BORDER="0">';
    }    
    if ($row != scalar(@m3u)-1){
      print "<A HREF=\"edit.cgi?down=$row&list=$list\">";
      print '<IMG SRC="movedown.gif" HEIGHT="16" WIDTH="16" TITLE="Move down" ALIGN="absmiddle" BORDER="0">';
      print "</A>";
    }else{
      print '<IMG SRC="blank.gif" HEIGHT="16" WIDTH="16" TITLE="" ALIGN="absmiddle" BORDER="0">';
    }

    print "<A HREF=\"play.cgi?music=$line\" TITLE=\"play\">";
    print "<SPAN CLASS=\"missing\" TITLE=\"File not found\">" unless (-e $REALDIR.$line);
    print $line;
    print "</SPAN>" unless (-e "$REALDIR/$line");
    print "</A> ";

    print "<BR>";

    $row++
  }
  print "<P>&gt;&gt; ".scalar(@m3u)." songs total &lt;&lt;</P>";
  print '<A NAME="bottom"></A>';
}
